<?php
/*
 * © Copyright 2007, 2008 IntraHealth International, Inc.
 * 
 * This File is part of iHRIS
 * 
 * iHRIS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * The page wrangler
 * 
 * This page loads the main HTML template for the home page of the site.
 * @package iHRIS
 * @subpackage DemoManage
 * @access public
 * @author Carl Leitner <litlfred@ibiblio.org>
 * @copyright Copyright &copy; 2007, 2008 IntraHealth International, Inc. 
 * @since Demo-v2.a
 * @version Demo-v2.a
 */



$dir = getcwd();
chdir("../pages");
$i2ce_site_user_access_init = null;
$wd = getcwd();

$i2ce_site_user_database = null;
require_once( $wd . DIRECTORY_SEPARATOR . 'config.values.php');

$local_config = $wd . DIRECTORY_SEPARATOR .'local' . DIRECTORY_SEPARATOR . 'config.values.php';
if (file_exists($local_config)) {
    require_once($local_config);
}

if(!isset($i2ce_site_i2ce_path) || !is_dir($i2ce_site_i2ce_path)) {
    echo "Please set the \$i2ce_site_i2ce_path in $local_config";
    exit(55);
}

require_once ($i2ce_site_i2ce_path . DIRECTORY_SEPARATOR . 'I2CE_config.inc.php');
if (isset($i2ce_site_dsn)) {
    @I2CE::initializeDSN($i2ce_site_dsn,   $i2ce_site_user_access_init,    $i2ce_site_module_config);         
} else if (isset($i2ce_site_database_user)) {    
    I2CE::initialize($i2ce_site_database_user,
                     $i2ce_site_database_password,
                     $i2ce_site_database,
                     $i2ce_site_user_database,
                     $i2ce_site_module_config         
        );
} else {
    die("Do not know how to configure system\n");
}






require_once($i2ce_site_i2ce_path . DIRECTORY_SEPARATOR . 'tools' . DIRECTORY_SEPARATOR . 'CLI.php');


$user = new I2CE_User();

require_once($i2ce_site_i2ce_path . DIRECTORY_SEPARATOR . 'tools' . DIRECTORY_SEPARATOR . 'import_base.php');
if (count($arg_files) != 1) {
    usage("Please specify the name of an  .CSV file to import");
}
reset($arg_files);
$file = current($arg_files);
if($file[0] == '/') {
    $file = realpath(current($arg_files));
} else {
    $file = realpath($dir. '/' . $file);
}

if (!is_readable($file) || ($fp = fopen($file,"r")) === false) {
    usage("Please specify the name of a .CSV spreadsheet to import: " . $file . " is not readable");
}

$in_file_sep = false;
foreach (array("\t",",") as $sep) {
    $headers = fgetcsv($fp, 4000, $sep);
    fseek($fp,0);
    if ( $headers === FALSE|| count($headers) < 10) {
        continue;
    }
    $in_file_sep = $sep;
}
if (!$in_file_sep) {
    die("Could not get headers\n");
}


$base_file = basename($file);
if ( ($pos = strrpos($base_file, '.')) === false) {
    usage("Please specify a .CSV file");
}
if (strtoupper( $ext = substr($base_file,$pos+1)) != 'CSV') {
    usage("Can only import a .CSV file");
}
$bad_file = dirname($file) . DIRECTORY_SEPARATOR . substr($base_file,0,$pos) . ".bad." . date('M_d_Y_H_i') . "." . $ext;

$test_mode = simple_prompt("Run in test mode (do not save any records)?");
$only_mlg = simple_prompt("Only Import MLG");
$default_fac_type = ask("Default Facility TPYE ID (0 for no deafult) when creating a new facility?");
$prefix = 'PLACEHOLDER-';
$do_prefix = simple_prompt("Prefix new facilities/jobs/salarygrade with $prefix?");
$skip_existing = simple_prompt("Skip import of people that already exist in the system (as checked by OMGANG number)?");
if (!$test_mode) {
    do {
        
    }while (!simple_prompt("Please restart your webserver when this scripts finishes running.\n\tsudo /etc/init.d/apache2 restart\n\tsudo /etc/init.d/memcached restart\nAll bad records will be stored in:\n\t$bad_file\nReady to Begin?"));
}


if ( ($omang_id_type = getFormIdByFields('id_type',array('name'=>'OMANG'))) === false) {
    usage("Could not get OMANGE id type");
}
if ( ($exception_id_type = getFormIdByFields('id_type',array('name'=>'EXCEPTION NUMBER'))) === false) {
    usage("Could not get EXPECTION NUMBER id type");
}


if ( ($botswana_id = getFormIdByFields('country',array('name'=>'BOTSWANA'))) === false) {
    usage("Could not find BOTSWANA in the country list");
}

$fac_types = I2CE_FormStorage::listDisplayFields('facility_type','name');
if (count($fac_types) == 0) {
    usage("No Facility Types");
}
foreach ($fac_types as &$fac_type) {
    $fac_type = trim(strtoupper($fac_type['name']));
}
unset($fac_type);
$facilities = I2CE_FormStorage::listDisplayFields('facility','name');
if (count($facilities) == 0) {
    usage("No Facilities");
}
foreach ($facilities as &$facility) {
    $facility = trim(strtoupper($facility['name']));
}
unset($facility);
$salary_grades = I2CE_FormStorage::listDisplayFields('salary_grade','name');
if (count($salary_grades) == 0) {
    usage("No Salary_Grades");
}
$sal_grade_formids = array();
foreach ($salary_grades as $id=>$salary_grade) {
    $sal_grade_formids[ 'salary_grade|' . $id ] = trim(strtoupper($salary_grade['name']));
}


$jobs = I2CE_FormStorage::listDisplayFields('job','title');
if (count($jobs) == 0) {
    usage("No Jobs");
}
foreach ($jobs as &$job) {
    $job = trim(strtoupper($job['title']));
}
unset($job);
$cadres = I2CE_FormStorage::listDisplayFields('cadre','name');
foreach ($cadres as &$cadre) {
    $cadre = trim(strtoupper($cadre['name']));
}
unset($cadre);
if (count($cadres) == 0) {
    usage("No Cadres set");
}

if (  ($job_cadre_map_fp = fopen(dirname(__FILE__) ."/../data/cadre_mapping_to_jobs.csv","r")) === false) {
    usage("Could not open '../data/cadre_mapping_to_jobs.csv'");
}
$row = 0;
$job_cadre_formid_map = array();
while (($data = fgetcsv($job_cadre_map_fp)) !== FALSE) {
    $row++;
    if ($row == 1 || count($data) != 2) {
        continue;
    }
    list($job,$cadre) = $data;
    $job = trim(strtoupper($job));
    $cadre = trim(strtoupper($cadre));
    if (!$job || !$cadre) {
        continue;
    }
    if ( ($cadre_id = array_search($cadre,$cadres)) === false) {
        //the cadre does not exist.  lets see if we need to create it
        $cadreData= array('name'=>$cadre);
        if (! ( $cadreObj = createFormWithFields('cadre',$cadreData)) instanceof iHRIS_Cadre) {
            continue;            
        }
        if ($test_mode) {
            $cadreObj->save($user);
            $cadre_id = $cadreObj->getID();
            $cadreObj->cleanup();
        } else {
            $cadre_id = md5(rand(0,32768));
        }
        $cadres[$cadre_id] = $cadre;

    }    
    $job_cadre_formid_map[$job] = 'cadre|' . $cadre_id;
}
fclose($job_cadre_map_fp);




  
function checkForExistingFacility($name) {
    global $fac_types;
    global $facilities;
    $name = trim(strtoupper($name));
    if ( ($pos = array_search($name,$facilities)) !== false) {
        return $pos;
    }
    foreach ($fac_types as $fac_type) {
        if ( ($pos = array_search($name . ' ' . $fac_type,$facilities)) !== false) {
            return $pos;
        }
    }
    return false;
}









// 1. For part 1, the data from infinium will be the authority since it
// was collected and entered very recently.  We have about 1000 records
// from the clinics so there will be some overlap. If overwriting data is
// a bad idea then I can remove these records from the .CSV when we
// import.

// 2.In infinium they allow more than one person to hold a position but
// for ihris we decided that it would be confusing for planning purposes
// so we split it. Preserving the code is not important for us but you
//     are right, its good to know where the data comes from.

// 3.Salary = Salary grade but in infinium they allow multi-graded
// positions. So you will find some people with grades like c1/c2/c3.  In
// ihris we use the exact pay grade because it is important for planning
//     purposes.  We already have the mapping for this, i.e. we know the
//     exact pay grade for each staff member.(I can send you the
//                                            spreadsheet).

// 4.The numbers under Authorized show the budgetted number of positions.
//  This will be replaced by staffing norms which are still being created
// so for now we dont need to retain this information.

// 5.A position without a person is vacant.   For this step 1 there wont
//     be any such positions, we will only be dealing with positions already
// filled up.

// 6.OMANG/Exception number is the id number of each employee. This would
// be the primary key for each record. Omang number is for locals and
//     exception number is for foreigners. In ihris, omang and exception
// number are the two identification types.

// 7.I think they only store age in infinium but let me get back to you
// on this. If I am right then the formula you propose should work fine.

// 8.In ihris we do not store location codes. The name of the facility
// will be enough to do the mapping.



$bp = null;

function badRecord($data,$reason,$notice = true) {
    global $bp;
    global $bad_file;
    global $headers;
    global $in_file_sep;
    if ($bp === null) {
        $bp = fopen($bad_file,"w");        
        if (!$bp) {
            I2CE::raiseError("Cannot open file for bad records.  Stopping on:\n"  . implode("\t",$data) . "\nbecause of $reason", E_USER_ERROR);
        }
        I2CE::raiseError("Saving bad personal data into $bad_file");
        $t_headers = $headers;
        $t_headers[] = 'reason';
        fputcsv($bp,$t_headers,$in_file_sep);
    }
    $data[] = $reason;
    fputcsv($bp,$data,$in_file_sep);
    if ($notice) {
        I2CE::raiseError($reason);
    }
}



$successes = 0;
$failures = 0;
$bads = 0;
$no_positions = 0;
$existing = 0;
$kc_count = 0; //i think position codes starting with KC are local governance

$i = 0;
$fac_type_message = "";
$fac_type_index = array();
foreach ($fac_types as $id=>$fac_type) {
    $fac_type_message .= "\t" . $i . ": " . $fac_type . "\n";    
    $fac_type_index[$i] = $id;
    $i++;
}

$add_facility = null;
$create_person = null;
$create_position = null;
$create_job = null;
$form_factory = I2CE_FormFactory::instance();
$columns =     array(
    'unit'=>'Unit',
    'pos_code'=>'Position',
    'pos_title'=>'Title',
    'sal_grade'=>'Grade',
    'emp_name'=>'Employee Name',
    'age'=>'AGE',
    'sex'=>'SEX',
    'id'=>'Omang/Excemption',
    );

$req_cols = array(
    'id' => 'No ID specified',
    'sal_grade'=>"NO Salary Grade",
    'unit'=>'No Unit specified',
    'pos_code'=>'No Position Code specified',
    'pos_title'=>'No Position Title specified',
    'emp_name'=>'No Employee name specified'
    );



function createFormWithFieldsBW($form,$fields,$parent = false,$id = '0') {
    global $user;
    global $form_factory;
    global $test_mode;
    $formObj = $form_factory->createForm($form);
    if (!$formObj instanceof I2CE_Form) {
        I2CE::raiseError("Could not instantiate form $form", E_USER_ERROR);
        return null;
    }
    foreach ($fields as $k=>$v) {
        $formObj->getField($k)->setFromDB($v);
    }
    if ($parent !== false) {
        $formObj->setParent($parent);
    }
    if ($id !== '0') {
        $formObj->setId($id);
    }
    if ($test_mode) {
        if ($id === '0') {
            $formObj->setId(md5(rand(0,32768)));
        }
    } else {
        $formObj->save($user);
    }
    return $formObj;
}




function setupColumnsBW($fp,$required_columns) {
    global $header_map;
    global $in_file_sep;
    $header_map = array();
    $headers = fgetcsv($fp,4000,$in_file_sep);
    if (!is_array($headers) || count($headers) == 0) {
        I2CE::raiseError("Could not get header information", E_USER_ERROR);
        return false;
    }    
    foreach ($required_columns as $field_name=>$header)  {
        $j = array_search($header,$headers);
        if ($j === false) {
            I2CE::raiseError("Could not find $header column",E_USER_ERROR);
            die();
        }
        $header_map[$field_name] = $j;
    }
    return $headers;
}


if (!setupColumnsBW($fp,$columns)) {
    usgage("Could not find columns");
}
//$only_once = false;
$i=1;
while ( ($import_data = fgetcsv($fp,4000,$in_file_sep)) !== false) {
    // if ($only_once) {
    //     echo "Ran once\n";
    //     die();
    // }
    //$only_once =true;
  
    $i++;
    //echo "Line $i: '" . implode("' , '",$import_data) . "'\n";;
    $bad = array();
    foreach ($req_cols as $col => $reason) {
        $val = trim(getColumn($col,$import_data));
        if (strlen($val) == 0) {
            $bad[] = $reason;
        }
    };    
    if (count($bad) > 0) {
        badRecord($import_data,implode(' AND ',$bad),true);
        $failures++;
        continue;
    }
    $pos_code_base = trim(getColumn('pos_code',$import_data));
    if (strtoupper(substr($pos_code_base,0,2)) == 'KC') {
        $kc_count++;
    } else if ($only_mlg) {
        continue;
    }

    $sal_grade = trim(strtoupper(getColumn('sal_grade',$import_data)));
    if ( ($sal_grade_formid = array_search($sal_grade,$sal_grade_formids)) === false) {
        if ($do_prefix) {            
            $sal_grade = $prefix . $sal_grade;
            if ( ($sal_grade_formid = array_search($sal_grade,$sal_grade_formids)) === false) {
                $salGradeObj = createFormWithFieldsBW('salary_grade',array('name'=>$sal_grade));
                $sal_grade_formid =$salGradeObj->getNameId(); 
                $sal_grade_formids[$sal_grade_formid] = $sal_grade;
                $salGradeObj->cleanup();
            }
        } else {
            badRecord($import_data,"Invalid Salary Grade",true);
            $failures++;
            continue;   
        }
    }
    
    //lets us see if we can get the person.
    $omang = strtoupper(trim(getColumn('id',$import_data)));
    if (ctype_digit($omang)) {
        //omange
        $id_type = $omang_id_type;
    }else if (in_array($omang, array('EXP', 'EXPATRIATE'))) {
        badRecord($import_data,'Invalid ID -- expatriate ' ,true);
        $failures++;
        continue;                    
    } else {
        $id_type = $exception_id_type;
        //exception id
    }
    $where = array(
        'operator'=>'AND',
        'operand'=>array(
            0=>array(
                'operator'=>'FIELD_LIMIT',
                'field'=>'id_type',
                'style'=>'equals',
                'data'=>array(
                    'value'=>'id_type|'.$id_type
                    )
                ),
            1=>array(
                'operator'=>'FIELD_LIMIT',
                'field'=>'id_num',
                'style'=>'equals',
                'data'=>array(
                    'value'=>$omang
                    )
                )
            )
        );
    $persons = I2CE_FormStorage::listFields('person_id',array('parent'),true,$where);
    $person_id = false;
    $check_for_existing_pos = false;
    if (count($persons) > 1) {
        badRecord($import_data,"Multiple matches for omang/expection:" . $omang);
        $failures++;
        continue;
    } else if (count($persons) == 1) {
        $check_for_existing_pos = true;
        reset($persons);
        $data = current($persons);
        if (array_key_exists('parent',$data) && is_string($data['parent']) && substr($data['parent'],0,7) == 'person|') {
            $person_id = substr($data['parent'],7);
        }            
        if ($person_id == '0') {
            badRecord($import_data,"No person found with id $omang" );
            $failures++;
            continue;
        }
        $existing++;
        if ($skip_existing) {
            badRecord($import_data,"Person already existings by OMGANG");
            continue;
        }
        $personObj = $form_factory->createForm('person|' . $person_id);
        if (!$personObj instanceof iHRIS_Person) {
            badRecord($import_data,"Could not create person id $omang");
            $failures++;
            continue;
        }
        $personObj->populate();
    }else {
        if (!prompt("No person found with id $omang. Create?", $create_person)) {
            badRecord($import_data,"Could not create person with id $omang");
            $failures++;
            continue;
        }
        $name = trim(getColumn('emp_name',$import_data));
        $name_components = preg_split('/[,\s*]/',$name,-1,PREG_SPLIT_NO_EMPTY);
        if (count($name_components) < 2) {
            badRecord($import_data,"Could figure out the name for [$name]:" . print_r($name_components,true));
            $failures++;
            continue;            
        }
        
        $data = array();
        $data['surname'] = strtoupper(array_shift($name_components));
        $data['firstname'] = strtoupper(array_shift($name_components));
        if (count($name_components) > 0) {
            $data['othername'] = strtoupper(implode( " ", $name_components));
        }
        $data['nationality']='country|'.$botswana_id;
        $personObj = createFormWithFieldsBW('person',$data);
        if (!$personObj instanceof iHRIS_Person) {
            badRecord($import_record,"Could not create person form");
            $failures++;
            continue;
        }        
        echo "Created $name with id " . $personObj->getId() . "\n";
        $personIDObj = createFormWithFieldsBW(
            'person_id',
            array(
                'id_type'=> 'id_type|' . $id_type,
                'id_num' => $omang
                ),
            $personObj);
        if (!$personIDObj instanceof I2CE_Form) {
            $personObj->cleanup();
            badRecord($import_record,"Could not create person_id form");
            $failures++;
            continue;
        }
        $personIDObj->cleanup();        
        //now do demographic.
        $data = array();

        if (strlen($gender = strtoupper(trim(getColumn('sex',$import_data)))) > 0) {
            if ($gender[0] == 'M') {
                $data['gender'] = 'gender|M';
            }else {
                $data['gender'] = 'gender|F';
            }
        }
        if ((strlen($age = strtoupper(trim(getColumn('age',$import_data)))) > 0) && (ctype_digit($age) || is_int($age))) {            
            $data['birth_date']= I2CE_Date::getDate('1','1',((int) date('Y')) - $age)->dbFormat();
        }
        if (count($data) > 0) {
            $demoObj = createFormWithFieldsBW('demographic',$data,$personObj);
            if (!$demoObj instanceof I2CE_Form) {
                $personObj->cleanup();
                badRecord($import_data ,"Could not create person demographics");
                $failures++;
                continue;
            }        
            $demoObj->cleanup();        
        }
    }
    //we now have a person.    
    
    


    if ($check_for_existing_pos){ //this is if the person is aleady in the system
        $where = array(
            'operator'=>'FIELD_LIMIT',
            'field'=>'end_date',
            'style'=>'null'
            );
        $child_ids = $personObj->getChildIds('person_position',array(),$where);
        if (count($child_ids) > 1) {
            badRecord($import_data, "Person already has more than one current position");
            $personObj->cleanup();
            $failures++;
            continue;
        } else if (count($child_ids) == 1) {
            badRecord($import_data, "This person has already been assigned a position in the system.");
            $failures++;
            $personObj->cleanup();
            $create_pos = false; 
            continue;
        }
    } 
    //the person was not already in the system

    //create a position code.
    $pos_code_count = 0;
    echo "Checking for availble position code: ";
    do {
        $pos_code_count++;
        $pos_code = $pos_code_base . '-' . str_pad( ((string) $pos_code_count),4,'0',STR_PAD_LEFT);
        echo " $pos_code";
    } while (  getFormIdByFields('position',array('code'=>$pos_code)) != "0");
    echo ". Found!\n";
    
    //if we are here, we need to create a position for this person.
    $pos_title = strtoupper(trim(getColumn('pos_title',$import_data)));
    if ( ($job_id = array_search($pos_title,$jobs)) === false) {
        //the job does not exist.  lets see if we need to create it
        $job_title = $pos_title;
        if ($do_prefix) {
            $job_title = $prefix . $job_title;
        }
        if ( !$do_prefix || ($job_id = array_search($job_title,$jobs)) === false) {
            $jobData= array('title'=>$job_title);
            if (array_key_exists($pos_title,$job_cadre_formid_map)) {
                //there is a cadre set for this job.
                $jobData['cadre'] = $job_cadre_formid_map[$pos_title];
            }
            if (! ( $jobObj = createFormWithFieldsBW('job',$jobData)) instanceof iHRIS_Job) {
                badRecord($import_data,'Could not create job ' . $job_title);
                $failures++;
                $personObj->cleanup();
                continue;            
            }
            $jobObj->salary_grade = explode('|',$sal_grade_formid);
            I2Ce::raiseError("Please set the cadre for the job $job_title if needed");
            if ($test_mode) {
                $job_id =  count($jobs) + 1;
            } else {
                $jobObj->save($user);
                $job_id = $jobObj->getID();
                $jobObj->cleanup();       
            }
            $jobs[$job_id] = $job_title;
        }
    } 


    //we got the job.  now lets get the facility
    $unit = strtoupper(trim(getColumn('unit',$import_data)));
    if ( ($unit_id = checkForExistingFacility($unit)) === false)  {
        $pos = false;
        $fac_type_id = false;
        $unit_id = false;
        foreach ($fac_types as $id=>$fac_type) {
            if ( ($pos = strpos($unit,$fac_type)) !== false  && $pos > 0) {
                $t_unit = substr($unit,0,$pos);                
                $fac_type_id = $id;
                if ( ($unit_id = checkForExistingFacility($t_unit)) !== false)  {
                    break ;
                }
            }
        }
        if (!$unit_id) {
            //here we could not find an existing facility (even after trying to pull out the facility type)
            if ($do_prefix) {
                $unit = $prefix . $unit;
            }
            if (!$do_prefix || ($unit_id = checkForExistingFacility($unit)) === false) {
                if (!prompt("Facility $unit was not found.  Attempt to create?",$add_facility)) {
                    badRecord($import_data,'No facility ' . $unit,true);
                    $personObj->cleanup();
                    $failures++;
                    continue;
                }
                if ($fac_type_id === false) {
                    if ($default_fac_type) {
                        $fac_type_id = $default_fac_type;
                    } else {
                        do {
                            $which = trim(ask("Please choose the facility type for $unit from the list:\n" . $fac_type_message . "\n"));
                        } while ( (!ctype_digit($which) && !is_int($which)) && ($which < 0 || $which > count($fac_type)));
                        $fac_type_id = $fac_type_index[$which];
                    }
                }
                if (! ( $facObj = createFormWithFieldsBW('facility',array('name'=>$unit,'facility_type'=>'facility_type|' . $fac_type_id))) instanceof iHRIS_Facility) {
                    badRecord($import_data,'Could not create facility ' . $unit,true);
                    $personObj->cleanup();
                    $failures++;
                    continue;            
                }
                if ($test_mode) {
                    $unit_id = md5(rand(0,32768));
                } else {
                    $facObj->save($user);
                    $unit_id = $facObj->getID();
                    $facObj->cleanup();
                }
                echo "Creating ($unit) with $unit_id\n";
                $facilities[$unit_id] = $unit;
            }
        }
    }
    
    $pos_data = array(
        'code'=>$pos_code,
        'title'=>$pos_title,
        'job'=>'job|'.$job_id,
        'facility'=>'facility|'.$unit_id,
        'status'=>'position_status|closed'
        );
    if ( ! ($posObj = $form_factory->createForm('position'))instanceof I2CE_Form) {
        badRecord($import_data,'Could not create position');
        $personObj->cleanup();
        $failures++;
        continue;                                
    }
    foreach ($pos_data as $k=>$v) {
        $posObj->getField($k)->setFromDB($v);
    }
    $posObj->validate();
    $inv = '';
    $has_invalid = false;
    foreach ($posObj as $fieldName=>$fieldObj) {
        if (!$fieldObj->hasInvalid()) {
            continue;
        }
        $has_invalid = true;
        $inv_data = $fieldObj->getInvalid();
        if ( is_string($inv_data )) {
            $inv .= $fieldName . '--' . $inv_data;
        } else if (is_array($inv_data)) {
            $inv .= $filedName . '--' . implode(',',$inv_data);
        } else {
                $inv .= $field ;
        }
    }
    if ($has_invalid) {
        badRecord($import_data,'Could not create position -- invalid data:' . $inv ,true);
        $posObj->cleanup();
        $personObj->cleanup();
        $failures++;
        continue;                                
    }
    if ($test_mode) {
        $pos_id = 32768 + (rand(0,32768));
    } else {
        $posObj->save($user);
        $pos_id = $posObj->getID();
        $posObj->cleanup();
    }
    if ( ! ($persPosObj = $form_factory->createForm('person_position'))instanceof I2CE_Form) {
        badRecord($import_data,'Could not create person_position');
        $personObj->cleanup();
        $posObj->cleanup();
        $failures++;
        continue;                                
    }
    $pos_data = array(
        'position'=>'position|' . $pos_id
        );
    foreach ($pos_data as $k=>$v) {
        $persPosObj->getField($k)->setFromDB($v);
    }
    //there is no start date -- so let us not validate
    // if (!$persPosObj->validate()) {
    //     badRecord($import_data,'Could not create person position -- invalid data ' . $unit,true);
    //     $persPosObj->cleanup();
    //     $posObj->cleanup();
    //     $personObj->cleanup();
    //     $failures++;
    //     continue;                                
    // } 
    $persPosObj->setParent($personObj);
    if (!$test_mode) {
        $persPosObj->save($user);
    }
    $persPosObj->cleanup();
    $personObj->cleanup();
    $successes++;
}


fclose($fp);
echo "Happy! with $successes uccesful imports\nDisgruntled! with $bads bad records\nSad! with $failures failed imports\nMad! with $no_positions people without a position\n";
echo "There are $existing people you tried to import but were already in the system\n";
echo "There are $kc_count created with posiiton code starting with KC (local governance?)\n";
if (!$test_mode) {
    echo "Please restart your webserver:\n\tsudo /etc/init.d/apache2 restart\n\tsudo /etc/init.d/memcached restart\n\n\n";
}
if ((count($bad) + count($failures)) > 0) {
    exit(1);
}

exit(0);









# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
